Package com.ocient.metrics

# Enum Class PerfCounter.ThreadingModel

java.lang.Object
java.lang.Enum<PerfCounter.ThreadingModel>
com.ocient.metrics.PerfCounter.ThreadingModel

All Implemented Interfaces:
  `Serializable`, `Comparable<PerfCounter.ThreadingModel>`, `Constable`

Enclosing class:
  PerfCounter

public static enum PerfCounter.ThreadingModel extends Enum<PerfCounter.ThreadingModel>
Threading model under which the counter will be mutated

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`HIGH_CONTENTION`
For use in highly contention multi-threaded contexts.
`LOW_CONTENTION`
For use in multi-producer contexts.
`NO_CONTENTION`
For use in single-producer contexts.

## Method Summary

Modifier and Type
Method
Description
`static PerfCounter.ThreadingModel`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static PerfCounter.ThreadingModel[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### NO_CONTENTION

public static final PerfCounter.ThreadingModel NO_CONTENTION
For use in single-producer contexts. Only use this is you can guarantee the counter will be updated by a single thread for the entirety of its lifespan.

### LOW_CONTENTION

public static final PerfCounter.ThreadingModel LOW_CONTENTION
For use in multi-producer contexts. This is the DEFAULT model, use it if you are unsure.

### HIGH_CONTENTION

public static final PerfCounter.ThreadingModel HIGH_CONTENTION
For use in highly contention multi-threaded contexts. Only select this if performance analysis points to contention on a particular counter.

## Method Details

### values

public static PerfCounter.ThreadingModel[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static PerfCounter.ThreadingModel valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null